@import url("https://fonts.googleapis.com/css2?family=Montserrat:wght@300;400;700&display=swap");
@import url("https://fonts.googleapis.com/css2?family=Lobster&display=swap");

$text-colour: #2c3e50;
$off-gray: #ecf0f1;
$colourful-gradient: linear-gradient(
  to right,
  #b8cbb8 0%,
  #b8cbb8 0%,
  #b465da 0%,
  #cf6cc9 33%,
  #ee609c 66%,
  #ee609c 100%
);
$btn-bg-gradient: linear-gradient(#fdfdfd, #f0f0f0);
$btn-box-shadow: 0 2.1px 1.3px rgba(0, 0, 0, 0.044),
  0 5.9px 4.2px rgba(0, 0, 0, 0.054), 0 12.6px 9.5px rgba(0, 0, 0, 0.061),
  0 25px 20px rgba(0, 0, 0, 0.1);
$btn-hover-box-shadow: 0 3.1px 2.3px rgba(0, 0, 0, 0.044),
  0 6.9px 5.2px rgba(0, 0, 0, 0.054), 0 13.6px 10.5px rgba(0, 0, 0, 0.061),
  0 26px 21px rgba(0, 0, 0, 0.1);

.btn {
  position: relative;
  background-color: #fff;
  background: transparent;
  color: $text-colour;
  border: none;
  border-radius: 10px;
  z-index: 0;

  &:hover {
    cursor: pointer;

    &::after {
      opacity: 0.9;
      background: $btn-hover-box-shadow;
      transition: box-shadow 400ms, opacity 400ms;
    }
  }

  &::after {
    content: "";
    position: absolute;
    display: block;
    top: 0;
    right: 0;
    width: 100%;
    height: 100%;
    background: $btn-bg-gradient;
    border-radius: 10px;
    box-shadow: $btn-box-shadow;
    opacity: 0.75;
    z-index: -1;
    transition: opacity 400ms;
  }

  &:focus {
    outline: none;
  }
}

@import "./Intro";
@import "./Joke";

* {
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

html,
body {
  width: 100%;
  height: 100%;
  color: $text-colour;
  font-family: "Montserrat", sans-serif;
}

.container {
  min-width: 100vw;
  min-height: 100vh;
  background-image: $colourful-gradient;
}

.jokes-container {
  position: relative;
  display: flex;
  flex-direction: column;
  align-items: center;
  color: #fff;
  text-align: center;

  .btn-container {
    display: flex;
    align-items: center;
    justify-content: center;

    .btn {
      margin: 0 15px;
    }
  }

  .favourites-btn {
    width: 85px;
    height: 85px;
    padding: 15px;
    border-radius: 50%;

    .favourite-icon {
      width: 100%;
      height: 100%;
    }

    &::after {
      border-radius: 50%;
    }
  }

  .shuffle-btn {
    width: 85px;
    height: 85px;
    padding: 15px;
    border-radius: 50%;

    .shuffle-icon {
      width: 100%;
      height: 100%;
      fill: $text-colour;
    }

    &::after {
      border-radius: 50%;
    }
  }

  .favourite-timer-btn {
    width: 85px;
    height: 85px;
    padding: 15px;
    border-radius: 50%;
    transform: rotate(0);
    z-index: 1;
    transition: transform 300ms ease-in-out;

    .plus-icon {
      width: 100%;
      height: 100%;
      fill: $text-colour;
    }

    .progress-bar {
      position: absolute;
      top: 0;
      left: 0;
      width: 90px;
      height: 90px;
      z-index: 5;

      circle {
        width: 100%;
        height: 100%;
        fill: none;
        stroke: transparent;
        stroke-width: 0;
        stroke-linecap: round;
        transform: translate(2.5px, 2.5px);
        transition: stroke-width 400ms, stroke-dashoffset 200ms;

        &:nth-child(2) {
          stroke: $text-colour;
          stroke-dasharray: 250;
          stroke-dashoffset: 250;
        }
      }
    }

    &:hover {
      transform: rotate(270deg);

      &::after {
        transform: rotate(-270deg);
      }
    }

    &::after {
      border-radius: 50%;
      transform: rotate(0);
      transition: transform 300ms ease-in-out, opacity 400ms;
    }

    &.in-progress {
      transform: rotate(495deg);

      &::after {
        transform: rotate(-495deg);
      }
    }

    &.progress-filling {
      .progress-bar {
        circle:nth-child(2) {
          stroke-width: 5;
          stroke-dashoffset: 1;
          transition: stroke-width 400ms, stroke-dashoffset 5000ms;
        }
      }
    }
  }
}

.joke-list {
  max-width: 720px;
  margin: 0;
  padding: 10px 20px;
}

.clear-cache-btn {
  position: fixed;
  bottom: 15px;
  right: 15px;
  padding: 0.5rem 1rem;
}
